<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>ToDo</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="canonical" href="https://todo.heck.app/">
<link rel="stylesheet" href="//heck.app/style.css">
<!-- link rel="icon" href="/todo.svg" type="image/svg+xml" sizes="any" -->
<style>
div.done, div.todo, div.new { height: 3.6ex; border: none; border-bottom: thin solid var(--heck-border-color); }
.done .heck-todo-list-item { text-decoration: line-through; }
.new .heck-todo-list-item { color: var(--heck-border-color); }
.new .heck-todo-list-item:focus { color: var(--heck-color); }
.new:hover .heck-todo-list-item { color: var(--heck-color); }
div:hover, div:hover * { background-color: var(--heck-border-color); }
div:hover .heck-todo-delete { display: inline; }
div.new:hover .heck-todo-delete { display: none; }
.heck-todo-list-item { margin-left: 0.1em; }
.heck-todo-delete { display: none; float: right; font-size: xx-small; cursor: pointer; }
</style>
<script src="//heck.app/heck.js"></script>
<script>
function save_list() {
	var items = document.getElementsByClassName("heck-todo-list-item");
	var tosave = [];
	for (var i = 0; i < items.length; i++) {
		if (items[i].parentNode.className == "new") {
			continue;
		}

		var item = {
			"task": items[i].innerHTML,
			"state": items[i].parentNode.className
		};
		tosave.push(item);
	}
	localStorage.todo_list = JSON.stringify(tosave);
}

function add_item(task, state) {
	var div = document.createElement("div");
	div.className = state;

	var check = document.createElement("input");
	check.type = "checkbox";
	if (state == "done") {
		check.checked = true;
	} else {
		check.checked = false;
	}
	check.onclick = function() {
		if (this.parentNode.className == "done") {
			this.parentNode.className = "todo";
		} else {
			this.parentNode.className = "done";
		}
		save_list();
	};
	div.appendChild(check);

	var item = document.createElement("span");
	var placeholder = "Add new item...";
	item.innerHTML = task;
	item.className = "heck-todo-list-item";
	item.contentEditable = "true";
	item.oninput = function() {
		if (this.parentNode.className == "new") {
			this.parentNode.className = "todo";
			add_item(placeholder, "new");
		}
		save_list();
	};

	if (state == "new") {
		item.onfocus = function() {
			this.innerHTML = "";
		};

		item.onblur = function() {
			if (this.innerHTML.trim() == "") {
				this.innerHTML = placeholder;
			} else {
				this.onfocus = null;
				this.onblur = null;
			}
		}
	}
	div.appendChild(item);

	var delbutton = document.createElement("span");
	delbutton.innerHTML = "&#x274c;";
	delbutton.className = "heck-todo-delete";
	delbutton.onclick = function() {
		var div = this.parentNode;
		if (div.className == "new") {
			return;
		}
		div.parentNode.removeChild(div);
		save_list();
	};
	div.appendChild(delbutton);
	
	document.getElementsByTagName("body")[0].appendChild(div);
}

function init() {
	heck("ToDo");
	var saved = [];
	if (localStorage.todo_list) {
		saved = JSON.parse(localStorage.todo_list);
	}

	for (var i = 0; i < saved.length; i++) {
		add_item(saved[i].task, saved[i].state);
	}

	add_item("Add new item...", "new");

	window.addEventListener("keydown", function(e) {
		if (e.key == "Enter") {
			save_list();
			e.preventDefault();
		}
	});
}
</script>
</head>
<body onload="init();">
</body>
</html>
